import { INetRequest } from "../../script/Engine/CatanEngine/NetManagerV2/Core/INetRequest";
import { INetResponse } from "../../script/Engine/CatanEngine/NetManagerV2/Core/INetResponse";
import { ClientData } from "../../shared/protocols/define/interface";
import { RpcSlot1SpinRequest, RpcSlot1SpinResponse } from "../../shared/protocols/Slot1Request";
import SlotSpinBase from "./SlotSpinBase";


export default abstract class SlotFgSpinBase extends SlotSpinBase {
	public *fgspin(clientData: ClientData, req: INetRequest<RpcSlot1SpinRequest>): IterableIterator<any> {
		const data: RpcSlot1SpinRequest = req.Data
		yield* this.init(clientData);

		// if (clientData.reqFree) {
		// 	const { count, freeData } = clientData.free;
		// 	const slotData: any = freeData[count];

		// 	const response: INetResponse<RpcSlot1SpinResponse> = {
		// 		Status: 0,
		// 		Method: req.Method,
		// 		Data: slotData,
		// 		IsValid: true
		// 	};
		// 	clientData.free.count++;
		// 	return response;
		// }
		const { nowFree, freeData } = clientData.free;
		const { count, totalGet } = clientData.reqFree;
		const slotData: any = freeData[count];

		if (clientData.reqFree && nowFree === count - 1) {
			if (totalGet) {
				slotData.get = [[1, totalGet]];
			}
			if (slotData.get) {
				clientData.money += slotData.get[0][1];
			}
			slotData["money"] = clientData.money;
		}

		const response: INetResponse<RpcSlot1SpinResponse> = {
			Status: 0,
			Method: req.Method,
			Data: slotData,
			IsValid: true
		};
		clientData.free.nowFree++;
		return response;
	}
}