import { INetRequest } from "../../script/Engine/CatanEngine/NetManagerV2/Core/INetRequest";
import { INetResponse } from "../../script/Engine/CatanEngine/NetManagerV2/Core/INetResponse";
import { ClientData } from "../../shared/protocols/define/interface";
import { RpcSlotReqRequest, RpcSlotReqResponse } from "../../shared/protocols/SlotRequest";
import SlotFgSpinBase from "./SlotFgSpinBase";

export default function* (clientData: ClientData, req: INetRequest<RpcSlotReqRequest>): IterableIterator<any> {
	const count = req.Data
	const { slotId } = clientData;
	let totalGet = clientData.reqFree.totalGet;

	let fgspin: SlotFgSpinBase;
	let AsyncFunction = async function () {
		let module = await import(`../slot${slotId}/fgspin`);
		fgspin = new module.default();
	};
	AsyncFunction();
	while (!fgspin) {
		yield;
	}

	yield* fgspin.init(clientData);
	const { freeData, totalFreeGet } = fgspin.getFree(count);
	totalGet += totalFreeGet;
	clientData.free = { nowFree: 0, freeData };
	clientData.reqFree = { count: count, totalGet };

	const response: INetResponse<RpcSlotReqResponse> = {
		Status: 0,
		Method: req.Method,
		Data: req.Data,
		IsValid: true
	};
	return response;
}